diff --git a/fftools/Makefile b/fftools/Makefile
index 81ad6c4f4f..f9334a5622 100644
--- a/fftools/Makefile
+++ b/fftools/Makefile
@@ -15,6 +15,8 @@ OBJS-ffmpeg +=                  \
     fftools/ffmpeg_mux.o        \
     fftools/ffmpeg_opt.o        \
 
+OBJS-ffmpeg-$(CONFIG_LIBASS) += fftools/text_to_bitmap.o
+
 define DOFFTOOL
 OBJS-$(1) += fftools/cmdutils.o fftools/opt_common.o fftools/$(1).o $(OBJS-$(1)-yes)
 $(1)$(PROGSSUF)_g$(EXESUF): $$(OBJS-$(1))
diff --git a/fftools/ffmpeg.c b/fftools/ffmpeg.c
index ae622492ee..251a3ce427 100644
--- a/fftools/ffmpeg.c
+++ b/fftools/ffmpeg.c
@@ -72,7 +72,7 @@
 # include "libavfilter/buffersink.h"
 
 #if CONFIG_LIBASS
-#include "libavcodec/text_to_bitmap.h"
+#include "fftools/text_to_bitmap.h"
 #endif
 
 #if HAVE_SYS_RESOURCE_H
@@ -3239,7 +3239,7 @@ static int init_output_stream(OutputStream *ost, AVFrame *frame,
                 return AVERROR_INVALIDDATA;
             }
             if (input_props == AV_CODEC_PROP_TEXT_SUB && output_props == AV_CODEC_PROP_BITMAP_SUB)
-                init_ass_context(input_streams, output_streams, nb_input_streams, nb_output_streams, ost->source_index, ost->index);
+                init_ass_context(ist, ost);
 #else
             if (input_props && output_props && input_props != output_props) {
                 snprintf(error, error_len,
@@ -4514,6 +4514,8 @@ static int transcode(void)
         ist = input_streams[i];
         if (ist->decoding_needed) {
             avcodec_close(ist->dec_ctx);
+            if (ist->dec_ctx->ass_context != NULL)     // This really has to be done here, sorry
+                free_ass_context(ist->dec_ctx->ass_context);
             if (ist->hwaccel_uninit)
                 ist->hwaccel_uninit(ist->dec_ctx);
         }
diff --git a/fftools/text_to_bitmap.c b/fftools/text_to_bitmap.c
index 52d161d7b1..b4a0157174 100644
--- a/fftools/text_to_bitmap.c
+++ b/fftools/text_to_bitmap.c
@@ -27,8 +27,8 @@
 #include "text_to_bitmap.h"
 
 #include "fftools/ffmpeg.h"
-#include "avcodec.h"
-#include "ass_split.h"
+#include "../libavcodec/avcodec.h"
+#include "../libavcodec/ass_split.h"
 
 /**
  * Holds the objects used by the rendering function so they don't have to be reinitialized every time
@@ -51,16 +51,8 @@ struct ASS_Context {
  * @param ist_i index of input stream for transcoding
  * @param ost_i index of output stream for transcoding
  */
-void init_ass_context(
-        InputStream **input_streams,
-        OutputStream **output_streams,
-        int nb_input_streams,
-        int nb_output_streams,
-        int ist_i,
-        int ost_i)
+void init_ass_context(InputStream *ist, OutputStream *ost)
 {
-    InputStream *ist = input_streams[ist_i];
-    OutputStream *ost = output_streams[ost_i];
     if (ist->dec_ctx->ass_context) return;
 
     ASS_Context *context = (ASS_Context *)malloc(sizeof(ASS_Context));
diff --git a/fftools/text_to_bitmap.h b/fftools/text_to_bitmap.h
index 29037150c2..a9b48c6cf3 100644
--- a/fftools/text_to_bitmap.h
+++ b/fftools/text_to_bitmap.h
@@ -21,8 +21,8 @@
  * text_to_bitmap header file
  */
 
-#ifndef AVCODEC_TEXT_TO_BITMAP_H
-#define AVCODEC_TEXT_TO_BITMAP_H
+#ifndef FFTOOLS_TEXT_TO_BITMAP_H
+#define FFTOOLS_TEXT_TO_BITMAP_H
 
 #include <ass/ass.h>
 #include "fftools/ffmpeg.h"
@@ -30,14 +30,8 @@
 struct ASS_Context;
 typedef struct ASS_Context ASS_Context;
 
-void init_ass_context(
-        InputStream **input_streams,
-        OutputStream **output_streams,
-        int nb_input_streams,
-        int nb_output_streams,
-        int ist_i,
-        int ost_i);
+void init_ass_context(InputStream *ist, OutputStream *ost);
 void render_avsub_ass(ASS_Context *, AVSubtitle *);
 void free_ass_context(ASS_Context *context);
 
-#endif //AVCODEC_TEXT_TO_BITMAP_H
+#endif //FFTOOLS_TEXT_TO_BITMAP_H
diff --git a/libavcodec/Makefile b/libavcodec/Makefile
index 6d28513129..cfaa6f196a 100644
--- a/libavcodec/Makefile
+++ b/libavcodec/Makefile
@@ -151,7 +151,6 @@ OBJS-$(CONFIG_RV34DSP)                 += rv34dsp.o
 OBJS-$(CONFIG_SINEWIN)                 += sinewin.o
 OBJS-$(CONFIG_SNAPPY)                  += snappy.o
 OBJS-$(CONFIG_STARTCODE)               += startcode.o
-OBJS-$(CONFIG_LIBASS)                  += text_to_bitmap.o
 OBJS-$(CONFIG_TEXTUREDSP)              += texturedsp.o
 OBJS-$(CONFIG_TEXTUREDSPENC)           += texturedspenc.o
 OBJS-$(CONFIG_TPELDSP)                 += tpeldsp.o
diff --git a/libavcodec/avcodec.c b/libavcodec/avcodec.c
index 1e308f39c2..d11f035481 100644
--- a/libavcodec/avcodec.c
+++ b/libavcodec/avcodec.c
@@ -42,10 +42,6 @@
 #include "thread.h"
 #include "version.h"
 
-#if CONFIG_LIBASS
-#include "libavcodec/text_to_bitmap.h"
-#endif
-
 #include "libavutil/ffversion.h"
 const char av_codec_ffversion[] = "FFmpeg version " FFMPEG_VERSION;
 
@@ -538,11 +534,6 @@ av_cold int avcodec_close(AVCodecContext *avctx)
     } else if (av_codec_is_decoder(avctx->codec))
         av_freep(&avctx->subtitle_header);
 
-#if CONFIG_LIBASS
-    if (av_codec_is_decoder(avctx->codec) && avctx->ass_context != NULL)
-        free_ass_context(avctx->ass_context);
-#endif
-
     avctx->codec = NULL;
     avctx->active_thread_type = 0;
 